



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[BZOJ 1028] [JSOI2007] 麻将 【枚举+贪心判断】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[BZOJ 1028] [JSOI2007] 麻将 【枚举+贪心判断】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:01:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：<a href="http://www.lydsy.com/JudgeOnline/problem.php?id=1028" rel="external nofollow noreferrer">BZOJ - 1028</a></p>
<h3>题目分析</h3>
<p>枚举听的是哪种牌，再枚举成对的是哪种牌，再贪心判断：</p>
<p>从1到n枚举每一种牌，如果这种牌的个数小于0，就返回不合法。</p>
<p>将这种牌的张数 % 3, 剩下的只能和 i + 1, i + 2 这两种牌构成顺，所以 Num[i + 1] -= Num[i]; Num[i + 2] -= Num[i];</p>
<p>牌的种类要枚举到 n + 2，因为第 n - 1 和第 n 种牌可能会减掉 n + 1，n + 2 的牌。</p>
<h3>代码</h3>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;cstdlib&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;algorithm&gt;

using namespace std;

const int MaxN = 400 + 5;

int n, m, Top;<br />
int Cnt[MaxN], Num[MaxN], Ans[MaxN];

int main()<br />
{<br />
	scanf("%d%d", &amp;n, &amp;m);<br />
	int a;<br />
	for (int i = 1; i &lt;= 3 * m + 1; ++i)<br />
	{<br />
		scanf("%d", &amp;a);<br />
		++Cnt[a];<br />
	}<br />
	bool Flag;<br />
	for (int i = 1; i &lt;= n; ++i)<br />
	{<br />
		for (int j = 1; j &lt;= n + 2; ++j) Num[j] = Cnt[j];<br />
		++Num[i];<br />
		for (int j = 1; j &lt;= n; ++j)<br />
		{<br />
			if (Num[j] &lt; 2) continue;<br />
			Num[j] -= 2;<br />
			Flag = true;<br />
			for (int k = 1; k &lt;= n + 2; ++k)<br />
			{<br />
				if (Num[k] &lt; 0)<br />
				{<br />
					Flag = false;<br />
					break;<br />
				}<br />
				Num[k] %= 3;<br />
				Num[k + 1] -= Num[k];<br />
				Num[k + 2] -= Num[k];<br />
			}<br />
			if (Flag)<br />
			{<br />
				Ans[++Top] = i;<br />
				break;<br />
			}<br />
			for (int k = 1; k &lt;= n + 2; ++k) Num[k] = Cnt[k];<br />
			++Num[i];<br />
		}<br />
	}<br />
	if (Top == 0) printf("NO\n");<br />
	else<br />
	{<br />
		for (int i = 1; i &lt;= Top - 1; ++i) printf("%d ", Ans[i]);<br />
		printf("%d\n", Ans[Top]);<br />
	}<br />
	return 0;<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxdovd9.html">&lbrack;ASP&period;NET MVC 小牛之路&rsqb;16 - Model 验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1v3mzq.html">Caliburn&period;Micro学习笔记&lpar;二&rpar;----Actions</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r6r579.html">C&num;中的线程三 &lpar;结合ProgressBar学习Control&period;BeginInvoke&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4wjxj9.html">从 MySQL&plus;MMM 到 MariaDB&plus;Galera Cluster &colon; 一个高可用性系统改造</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgry49.html">pycharm安装python模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrp3wq.html">bootstrap实现弹出窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6mjdq.html">Elasticsearch在Windows下的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oojey9.html">CentOS系统下各文件夹的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdey5ox9.html">LED驅動芯片 兩種恒流控制方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmw5n09.html">Android中的windowSoftInputMode属性详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdplg3zq.html">【编程技巧】ExtJs 设置GridPanel表格文本垂直居中</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5poe9.html">c&num; 制作正方形图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4eerz9.html">1、SpringBoot bean&comma;list&comma;map Json返回</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grj0mq.html">T55359 家庭作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1zez49.html">jpa   &commat;RepositoryRestResource</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21onx9.html">OJ题解记录计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rpwjo9.html">Glide和Govendor安装和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vnkrq.html">Java&colon; md5 加密中文 &amp;amp&semi; 注意编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q251oovq.html">MySQL 基础 DDL和DML</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o16n6eq.html">mysql表分区存储过程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k16m639.html">用WidgeDuino创建一个SCADA（监控与数据採集）系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnjlpv8.html">九度OJ 题目1384：二维数组中的查找</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdpy748.html">Android TextView中有图片有文字混合排列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdp5n38.html">Java中List和ArrayList的区别&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k16n359.html">linux内存管理系列    &plus;CFS 图解</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o25jv9.html">careercup-链表 2&period;1</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y5nd3q.html">SourceTree - 好用的 Git &sol; Mercurial GUI 管理工具 for Mac OS X</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1p4l19.html">XC文件管理器（Android应用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j06lwwq.html">Eureka Web UI URL&lpar;eureka显示主界面路径设定&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xlzxe8.html">OpenCV 2 Computer Vision Application Programming Cookbook读书笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
